//dir.xyz is the direction the ray should calculate a background for
//RaytraceInfo is defined in bin/raytrace_half.cl
//state = 0 means that background should be calculated
//recursion is the number of reflections that the ray has gone through before coming here

kernel void background(global float4* dir, 
					global RaytraceInfo* work,
					int recursion)
{
	float anim = ANIM;  //ANIM is predefined to the current movie frame
	float width = WIDTH;  //WIDTH is predefined to image width
	float height = HEIGHT;  //HEIGHT is predefined to image height
    int x = get_global_id(0);
	RaytraceInfo rtmp = work[x];
	if(rtmp.state == 0){
		float3 ddir = normalize(dir[x].xyz);
		float3 center = normalize((float3)(.0,-3.0,-2.0));
		
		float dist = 2.0 * (1.0 - length(ddir - center));
		
		float3 col = (float3)(1.0, 0.5, 0.8);
		//float3 col = (float3)(0.18, 0.15, 0.44);
		//float3 col = (float3)(0.18, 0.44, 0.15);
		
		int xx = x % WIDTH;
		int yy = x / WIDTH;
		
		float dx = (float)yy / height - 0.5;
		float dy = (float)xx / width - 0.5;
		float d = 1.0 - sqrt(dx*dx+dy*dy);
		
		
		
		work[x].sphere_color = (float4)(d * col, 1.0);  //RGBA
	}
}

