//The contents of this file is public domain. No warranty implied. Use at your own risk.
#ifdef SPHERESIZE
#undef SPHERESIZE
#endif
#define SPHERESIZE %0

kernel void shadow%0(global half* restrict spheres
                   ,global half* restrict bounding_spheres
                   ,global unsigned int* restrict bounding_ref
                   ,float4 big_bound
                   ,int bounding_start
                   ,int bounding_end
                   ,unsigned int start
                   ,unsigned int end
				   ,float4 lightsource
				   ,unsigned int shadowflag
                   ,global void* restrict work
#if (SPHERESIZE==0)
				   ,float sphere_size
#endif
				   )
{
    int x = get_global_id(0);
	global unsigned int* uiwork = (global unsigned int*)work;
	unsigned int shadow_state = uiwork[x*4];
	if ((shadow_state & shadowflag) == 0) {
		global float4* f4work = (global float4*)work;
		float3 origin = f4work[x].yzw;
		float3 dir = normalize(lightsource.xyz - origin);
		float sq_bbradius = big_bound.w * big_bound.w;
		float3 bbp_a = big_bound.xyz - origin;
		float bbp_an = dot(bbp_a, dir);
		float sq_bbndist = sq_point(big_bound.xyz, origin + (bbp_an * dir));
		if(sq_bbndist <= sq_bbradius){
			//float dist_origin2light = native_sqrt(sq_point(lightsource.xyz, origin.xyz));
			float sq_dist_origin2light = sq_point(lightsource.xyz, origin);
			for(int b = bounding_start; b <= bounding_end; b++){
				float4 bsphere = vloada_half4(b, bounding_spheres);
				float sq_bradius = bsphere.w * bsphere.w;
				float3 bp_a = bsphere.xyz - origin;
				float bp_an = dot(bp_a, dir);
				float sq_bndist = sq_point(bsphere.xyz, origin + (bp_an * dir));
				if(sq_bndist <= sq_bradius){
					unsigned int startix = (b == 0) ? 0 : bounding_ref[b-1];
					startix = max(start,startix);
					unsigned int endix = min(end, bounding_ref[b]);
					for(unsigned int i = startix; i < endix; i++){
						float4 sphere;
#if (SPHERESIZE==1)
						sphere = vloada_half4(i, spheres);
#else
						sphere.x = vloada_half(i*3, spheres);
						sphere.y = vloada_half(i*3+1, spheres);
						sphere.z = vloada_half(i*3+2, spheres);
						sphere.w = sphere_size;
#endif
						sphere.xyz += bsphere.xyz;
						float sq_radius = sphere.w * sphere.w;
						float3 p_a = sphere.xyz - origin;
						float p_an = dot(p_a, dir);
						if(p_an <= sq_dist_origin2light){
							float sq_ndist = sq_point(sphere.xyz, origin + (p_an * dir));
							if(sq_ndist <= sq_radius){
								float dist_exact = p_an - (sphere.w - native_sqrt(sq_ndist));
								if (dist_exact >= 0.0f) {
									shadow_state |= shadowflag;
									uiwork[x*4] = shadow_state;
									return;
								}
							}
						}
					}
				}
			}
		}
	}
}
